Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/trasbc.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/trasbc.F90	(revision 2023)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/trasbc.F90	(revision 2024)
@@ -17,6 +17,6 @@
    USE phycst          ! physical constant
    USE traqsr          ! solar radiation penetration
-   USE trdmod          ! ocean trends 
-   USE trdmod_oce      ! ocean variables trends
+   USE trdmod_oce      ! ocean trends 
+   USE trdtra          ! ocean trends
    USE in_out_manager  ! I/O manager
    USE prtctl          ! Print control
@@ -100,6 +100,4 @@
       !!              - save the trend it in ttrd ('key_trdtra')
       !!----------------------------------------------------------------------
-      USE oce, ONLY :   ztrdt => ua   ! use ua as 3D workspace   
-      USE oce, ONLY :   ztrds => va   ! use va as 3D workspace   
       !!
       INTEGER, INTENT(in) ::   kt     ! ocean time-step index
@@ -110,4 +108,5 @@
       REAL(wp) ::   zsrau, zse3t, zdep   ! temporary scalars, 1/density, 1/height of box, 1/height of effected water column  
       REAL(wp) ::   zdheat, zdsalt       ! total change of temperature and salinity  
+      REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  ztrdt, ztrds
       !!----------------------------------------------------------------------
 
@@ -123,7 +122,7 @@
 #endif
 
-      IF( l_trdtra ) THEN           ! Save ta and sa trends
-         ztrdt(:,:,:) = ta(:,:,:) 
-         ztrds(:,:,:) = sa(:,:,:) 
+      IF( l_trdtra )   THEN                    !* Save ta and sa trends
+         ALLOCATE( ztrdt(jpi,jpj,jpk) )   ;    ztrdt(:,:,:) = tsa(:,:,:,jp_tem)
+         ALLOCATE( ztrds(jpi,jpj,jpk) )   ;    ztrds(:,:,:) = tsa(:,:,:,jp_sal)
       ENDIF
 
@@ -138,76 +137,75 @@
             IF( lk_vvl) THEN
                zta =  ro0cpr * qns(ji,jj) * zse3t &                  ! temperature : heat flux 
-                &    - emp(ji,jj) * zsrau * tn(ji,jj,1) * zse3t      ! & cooling/heating effet of EMP flux 
+                &    - emp(ji,jj) * zsrau * tsn(ji,jj,1,jp_tem) * zse3t      ! & cooling/heating effet of EMP flux 
                zsa = ( emps(ji,jj) - emp(ji,jj) ) &
-                &                 * zsrau * sn(ji,jj,1)  * zse3t     ! concent./dilut. effect due to sea-ice 
+                &                 * zsrau * tsn(ji,jj,1,jp_sal) * zse3t     ! concent./dilut. effect due to sea-ice 
                                                                      ! melt/formation and (possibly) SSS restoration
             ELSE
                zta =  ro0cpr * qns(ji,jj) * zse3t                    ! temperature : heat flux 
-               zsa =  emps(ji,jj) * zsrau * sn(ji,jj,1) * zse3t      ! salinity :  concent./dilut. effect 
+               zsa =  emps(ji,jj) * zsrau * tsn(ji,jj,1,jp_sal) * zse3t      ! salinity :  concent./dilut. effect 
             ENDIF
-            ta(ji,jj,1) = ta(ji,jj,1) + zta                          ! add the trend to the general tracer trend
-            sa(ji,jj,1) = sa(ji,jj,1) + zsa
+            tsa(ji,jj,1,jp_tem) = tsa(ji,jj,1,jp_tem) + zta                  ! add the trend to the general tracer trend
+            tsa(ji,jj,1,jp_sal) = tsa(ji,jj,1,jp_sal) + zsa
          END DO
       END DO
 
       IF ( ln_rnf .AND. ln_rnf_att ) THEN  
-      ! Concentration / dilution effect on (t,s) due to river runoff  
-        DO jj=1,jpj  
-           DO ji=1,jpi  
-              rnf_dep(ji,jj)=0  
-              DO jk=1,rnf_mod_dep(ji,jj)                          ! recalculates rnf_dep to be the depth  
-                rnf_dep(ji,jj)=rnf_dep(ji,jj)+fse3t(ji,jj,jk)    ! in metres to the bottom of the relevant grid box  
+        ! Concentration / dilution effect on (t,s) due to river runoff  
+        DO jj = 1, jpj  
+           DO ji = 1, jpi  
+              rnf_dep(ji,jj) = 0.  
+              DO jk = 1, rnf_mod_dep(ji,jj)                          ! recalculates rnf_dep to be the depth  
+                rnf_dep(ji,jj) = rnf_dep(ji,jj) + fse3t(ji,jj,jk)    ! in metres to the bottom of the relevant grid box  
               ENDDO  
               zdep = 1. / rnf_dep(ji,jj)  
               zse3t= 1. / fse3t(ji,jj,1)  
-              IF ( rnf_tmp(ji,jj) == -999 )   rnf_tmp(ji,jj)=tn(ji,jj,1)        ! if not specified set runoff temp to be sst  
-  
-              IF ( rnf(ji,jj) .gt. 0.0 ) THEN  
-  
-                IF( lk_vvl) THEN  
-                  !!!indirect flux, concentration or dilution effect  
-                  !!!force a dilution effect in all levels;  
-                  zdheat=0.0  
-                  zdsalt=0.0  
-                  DO jk=1, rnf_mod_dep(ji,jj)  
-                    zta = -tn(ji,jj,jk) * rnf(ji,jj) * zsrau * zdep  
-                    zsa = -sn(ji,jj,jk) * rnf(ji,jj) * zsrau * zdep  
-                    ta(ji,jj,jk)=ta(ji,jj,jk)+zta  
-                    sa(ji,jj,jk)=sa(ji,jj,jk)+zsa  
-                    zdheat=zdheat+zta*fse3t(ji,jj,jk)  
-                    zdsalt=zdsalt+zsa*fse3t(ji,jj,jk)  
+              IF ( rnf_tmp(ji,jj) == -999 )   rnf_tmp(ji,jj) = tsn(ji,jj,1,jp_tem)    ! if not specified set runoff temp to be sst  
+  
+              IF ( rnf(ji,jj) > 0.0 ) THEN  
+  
+                IF( lk_vvl ) THEN  
+                  ! indirect flux, concentration or dilution effect : force a dilution effect in all levels 
+                  zdheat = 0.0  
+                  zdsalt = 0.0  
+                  DO jk = 1, rnf_mod_dep(ji,jj)  
+                    zta = -tsn(ji,jj,jk,jp_tem) * rnf(ji,jj) * zsrau * zdep  
+                    zsa = -tsn(ji,jj,jk,jp_sal) * rnf(ji,jj) * zsrau * zdep  
+                    tsa(ji,jj,jk,jp_tem) = tsa(ji,jj,jk,jp_tem) + zta                  ! add the trend to the general tracer trend
+                    tsa(ji,jj,jk,jp_sal) = tsa(ji,jj,jk,jp_sal) + zsa
+                    zdheat = zdheat + zta * fse3t(ji,jj,jk)  
+                    zdsalt = zdsalt + zsa * fse3t(ji,jj,jk)  
                   ENDDO  
-                  !!!negate this total change in heat and salt content from top level  
-                  zta=-zdheat*zse3t  
-                  zsa=-zdsalt*zse3t  
-                  ta(ji,jj,1)=ta(ji,jj,1)+zta  
-                  sa(ji,jj,1)=sa(ji,jj,1)+zsa  
+                  ! negate this total change in heat and salt content from top level  
+                  zta = -zdheat * zse3t  
+                  zsa = -zdsalt * zse3t  
+                  tsa(ji,jj,1,jp_tem) = tsa(ji,jj,1,jp_tem) + zta                  ! add the trend to the general tracer trend
+                  tsa(ji,jj,1,jp_sal) = tsa(ji,jj,1,jp_sal) + zsa
     
-                  !!!direct flux  
+                  ! direct flux  
                   zta = rnf_tmp(ji,jj) * rnf(ji,jj) * zsrau * zdep  
                   zsa = rnf_sal(ji,jj) * rnf(ji,jj) * zsrau * zdep  
     
-                  DO jk=1, rnf_mod_dep(ji,jj)  
-                    ta(ji,jj,jk) = ta(ji,jj,jk) + zta  
-                    sa(ji,jj,jk) = sa(ji,jj,jk) + zsa  
+                  DO jk = 1, rnf_mod_dep(ji,jj)  
+                    tsa(ji,jj,jk,jp_tem) = tsa(ji,jj,jk,jp_tem) + zta                  ! add the trend to the general tracer trend
+                    tsa(ji,jj,jk,jp_sal) = tsa(ji,jj,jk,jp_sal) + zsa
                   ENDDO  
    
                 ELSE  
-                  DO jk=1, rnf_mod_dep(ji,jj)  
-                    zta = ( rnf_tmp(ji,jj)-tn(ji,jj,jk) ) * rnf(ji,jj) * zsrau * zdep  
-                    zsa = ( rnf_sal(ji,jj)-sn(ji,jj,jk) ) * rnf(ji,jj) * zsrau * zdep  
-                    ta(ji,jj,jk) = ta(ji,jj,jk) + zta  
-                    sa(ji,jj,jk) = sa(ji,jj,jk) + zsa  
+                  DO jk = 1, rnf_mod_dep(ji,jj)  
+                    zta = ( rnf_tmp(ji,jj) - tsn(ji,jj,jk,jp_tem) ) * rnf(ji,jj) * zsrau * zdep  
+                    zsa = ( rnf_sal(ji,jj) - tsn(ji,jj,jk,jp_sal) ) * rnf(ji,jj) * zsrau * zdep  
+                    tsa(ji,jj,jk,jp_tem) = tsa(ji,jj,jk,jp_tem) + zta                  ! add the trend to the general tracer trend
+                    tsa(ji,jj,jk,jp_sal) = tsa(ji,jj,jk,jp_sal) + zsa
                   ENDDO  
                 ENDIF  
   
-              ELSEIF (rnf(ji,jj) .lt. 0.) THEN   !! for use in baltic when flow is out of domain, want no change in temp and sal  
-  
-                IF( lk_vvl) THEN  
-                  !calculate automatic adjustment to sal and temp due to dilution/concentraion effect   
-                  zata = tn(ji,jj,1) * rnf(ji,jj) * zsrau * zse3t  
-                  zasa = sn(ji,jj,1) * rnf(ji,jj) * zsrau * zse3t  
-                  ta(ji,jj,1)=ta(ji,jj,1) + zata  
-                  sa(ji,jj,1)=sa(ji,jj,1) + zasa  
+              ELSE IF( rnf(ji,jj) > 0.) THEN   ! for use in baltic when flow is out of domain, want no change in temp and sal  
+  
+                IF( lk_vvl ) THEN  
+                  ! calculate automatic adjustment to sal and temp due to dilution/concentraion effect   
+                  zata = tsn(ji,jj,1,jp_tem) * rnf(ji,jj) * zsrau * zse3t  
+                  zasa = tsn(ji,jj,1,jp_sal) * rnf(ji,jj) * zsrau * zse3t  
+                  tsa(ji,jj,1,jp_tem) = tsa(ji,jj,1,jp_tem) + zata                  ! add the trend to the general tracer trend
+                  tsa(ji,jj,1,jp_sal) = tsa(ji,jj,1,jp_sal) + zasa
                 ENDIF  
   
@@ -226,12 +224,12 @@
 #endif
               IF( lk_vvl) THEN
-                 zta =  rnf(ji,jj) * zsrau * tn(ji,jj,1) * zse3t       ! & cooling/heating effect of runoff
-                 zsa = 0.e0                                            ! No salinity concent./dilut. effect
+                 zta =    rnf(ji,jj) * zsrau * tsn(ji,jj,1,jp_tem) * zse3t       ! & cooling/heating effect of runoff
+                 zsa =    0.e0                                            ! No salinity concent./dilut. effect
               ELSE
-                 zta =  0.0                                            ! temperature : heat flux 
-                 zsa =  - rnf(ji,jj) * zsrau * sn(ji,jj,1) * zse3t     ! salinity :  concent./dilut. effect
+                 zta =    0.0                                            ! temperature : heat flux 
+                 zsa =  - rnf(ji,jj) * zsrau * tsn(ji,jj,1,jp_sal) * zse3t     ! salinity :  concent./dilut. effect
               ENDIF
-              ta(ji,jj,1) = ta(ji,jj,1) + zta                          ! add the trend to the general tracer trend
-              sa(ji,jj,1) = sa(ji,jj,1) + zsa
+              tsa(ji,jj,1,jp_tem) = tsa(ji,jj,1,jp_tem) + zta          ! add the trend to the general tracer trend
+              tsa(ji,jj,1,jp_sal) = tsa(ji,jj,1,jp_sal) + zsa
            END DO
         END DO
@@ -239,12 +237,14 @@
       ENDIF  
 
-      IF( l_trdtra ) THEN      ! save the sbc trends for diagnostic
-         ztrdt(:,:,:) = ta(:,:,:) - ztrdt(:,:,:)
-         ztrds(:,:,:) = sa(:,:,:) - ztrds(:,:,:)
-         CALL trd_mod(ztrdt, ztrds, jptra_trd_nsr, 'TRA', kt)
+      IF( l_trdtra )   THEN                      ! save the horizontal diffusive trends for further diagnostics
+         ztrdt(:,:,:) = tsa(:,:,:,jp_tem) - ztrdt(:,:,:)
+         ztrds(:,:,:) = tsa(:,:,:,jp_sal) - ztrds(:,:,:)
+         CALL trd_tra( kt, 'TRA', jp_tem, jptra_trd_nsr, ztrdt )
+         CALL trd_tra( kt, 'TRA', jp_sal, jptra_trd_nsr, ztrds )
+         DEALLOCATE( ztrdt )      ;     DEALLOCATE( ztrds )
       ENDIF
       !
-      IF(ln_ctl)   CALL prt_ctl( tab3d_1=ta, clinfo1=' sbc  - Ta: ', mask1=tmask,   &
-         &                       tab3d_2=sa, clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
+      IF(ln_ctl)   CALL prt_ctl( tab3d_1=tsa(:,:,:,jp_tem), clinfo1=' sbc  - Ta: ', mask1=tmask,   &
+         &                       tab3d_2=tsa(:,:,:,jp_sal), clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
       !
    END SUBROUTINE tra_sbc
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/traswp.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/traswp.F90	(revision 2024)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/traswp.F90	(revision 2024)
@@ -0,0 +1,52 @@
+MODULE traswp
+   !!==============================================================================
+   !!                       ***  MODULE  traswp  ***
+   !! Ocean active tracers: swapping array 
+   !!==============================================================================
+   USE par_oce
+   USE oce             ! ocean dynamics and active tracers
+
+   IMPLICIT NONE
+   PRIVATE
+
+   PUBLIC   tra_swap    ! routine called by step.F90
+   PUBLIC   tra_unswap    ! routine called by step.F90
+
+   !!----------------------------------------------------------------------
+   !!   OPA 9.0 , LOCEAN-IPSL (2005) 
+   !! $Id: trasbc.F90 1739 2009-11-19 13:24:00Z rblod $
+   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+
+CONTAINS
+
+   SUBROUTINE tra_swap 
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE tra_swp  ***
+      !!                   
+      !! ** Purpose : Store temperature and salinity aaray into a 4D array 
+      !!
+      !!----------------------------------------------------------------------
+
+      tsn(:,:,:,jp_tem) = tn(:,:,:)      ;      tsn(:,:,:,jp_sal) = sn(:,:,:)
+      tsb(:,:,:,jp_tem) = tb(:,:,:)      ;      tsb(:,:,:,jp_sal) = sb(:,:,:)
+      tsa(:,:,:,jp_tem) = ta(:,:,:)      ;      tsa(:,:,:,jp_sal) = sa(:,:,:)
+
+   END SUBROUTINE tra_swap
+
+   SUBROUTINE tra_unswap 
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE tra_unswap  ***
+      !!                   
+      !! ** Purpose : Store temperature and salinity aaray into a 4D array 
+      !!
+      !!----------------------------------------------------------------------
+
+      tn(:,:,:) = tsn(:,:,:,jp_tem)      ;      sn(:,:,:) = tsn(:,:,:,jp_sal)
+      tb(:,:,:) = tsb(:,:,:,jp_tem)      ;      sb(:,:,:) = tsb(:,:,:,jp_sal)
+      ta(:,:,:) = tsa(:,:,:,jp_tem)      ;      sa(:,:,:) = tsa(:,:,:,jp_sal)
+
+   END SUBROUTINE tra_unswap
+
+   !!======================================================================
+END MODULE traswp
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/trazdf.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/trazdf.F90	(revision 2023)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/trazdf.F90	(revision 2024)
@@ -4,5 +4,6 @@
    !! Ocean active tracers:  vertical component of the tracer mixing trend
    !!==============================================================================
-   !! History :  9.0  !  05-11  (G. Madec)  Original code
+   !! History :  9.0  ! 2005-11  (G. Madec)  Original code
+   !!       NEMO 3.0  ! 2008-01  (C. Ethe, G. Madec)  merge TRC-TRA
    !!----------------------------------------------------------------------
 
@@ -21,6 +22,6 @@
 
    USE ldftra_oce      ! ocean active tracers: lateral physics
-   USE trdmod          ! ocean active tracers trends 
-   USE trdmod_oce      ! ocean variables trends
+   USE trdmod_oce      ! ocean active tracers: lateral physics
+   USE trdtra      ! ocean tracers trends 
    USE in_out_manager  ! I/O manager
    USE prtctl          ! Print control
@@ -33,9 +34,9 @@
    PRIVATE
 
-   PUBLIC tra_zdf   !  routine called by step.F90
+   PUBLIC tra_zdf      !  routine called by step.F90
+   PUBLIC tra_zdf_init !  routine called by opa.F90
 
    INTEGER ::   nzdf = 0               ! type vertical diffusion algorithm used
       !                                ! defined from ln_zdf...  namlist logicals)
-
    REAL(wp), DIMENSION(jpk) ::   r2dt  ! vertical profile time-step, = 2 rdttra
       !                                ! except at nit000 (=rdttra) if neuler=0
@@ -62,8 +63,6 @@
 
       INTEGER  ::   jk                   ! Dummy loop indices
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   ztrdt, ztrds   ! 3D workspace
+      REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::   ztrdt, ztrds   ! 3D workspace
       !!---------------------------------------------------------------------
-
-      IF( kt == nit000 )   CALL zdf_ctl          ! initialisation & control of options
 
       !                                          ! set time step
@@ -74,44 +73,45 @@
       ENDIF
 
-      IF( l_trdtra )   THEN                      ! temporary save of ta and sa trends
-         ztrdt(:,:,:) = ta(:,:,:)
-         ztrds(:,:,:) = sa(:,:,:)
+      IF( l_trdtra )   THEN                    !* Save ta and sa trends
+         ALLOCATE( ztrdt(jpi,jpj,jpk) )   ;    ztrdt(:,:,:) = tsa(:,:,:,jp_tem)
+         ALLOCATE( ztrds(jpi,jpj,jpk) )   ;    ztrds(:,:,:) = tsa(:,:,:,jp_sal)
       ENDIF
 
       SELECT CASE ( nzdf )                       ! compute lateral mixing trend and add it to the general trend
+      CASE ( 0 )    ;    CALL tra_zdf_exp( kt , 'TRA', r2dt, nn_zdfexp,  &
+                         &                 tsb, tsa  , jpts              )    !   explicit scheme
+      CASE ( 1 )    ;    CALL tra_zdf_imp( kt , 'TRA', r2dt,             &
+                         &                 tsb, tsa  , jpts              )    !   implicit scheme
       CASE ( -1 )                                       ! esopa: test all possibility with control print
-         CALL tra_zdf_exp    ( kt, r2dt )
-         CALL prt_ctl( tab3d_1=ta, clinfo1=' zdf0 - Ta: ', mask1=tmask,               &
-            &          tab3d_2=sa, clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
-         CALL tra_zdf_imp    ( kt, r2dt )
-         CALL prt_ctl( tab3d_1=ta, clinfo1=' zdf1 - Ta: ', mask1=tmask,               &
-            &          tab3d_2=sa, clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
-
-      CASE ( 0 )                                       ! explicit scheme
-         CALL tra_zdf_exp    ( kt, r2dt )
-
-      CASE ( 1 )                                       ! implicit scheme 
-         CALL tra_zdf_imp    ( kt, r2dt )
-
+                         CALL tra_zdf_exp( kt , 'TRA', r2dt, nn_zdfexp,  &
+                         &                 tsb, tsa  , jpts              ) 
+                         CALL prt_ctl( tab3d_1=tsa(:,:,:,jp_tem), clinfo1=' zdf0 - Ta: ', mask1=tmask,               &
+                         &             tab3d_2=tsa(:,:,:,jp_sal), clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
+                         CALL tra_zdf_imp( kt , 'TRA', r2dt,             &
+                         &                 tsb, tsa  , jpts              ) 
+                         CALL prt_ctl( tab3d_1=tsa(:,:,:,jp_tem), clinfo1=' zdf1 - Ta: ', mask1=tmask,               &
+                         &             tab3d_2=tsa(:,:,:,jp_sal), clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
       END SELECT
 
       IF( l_trdtra )   THEN                      ! save the vertical diffusive trends for further diagnostics
          DO jk = 1, jpkm1
-            ztrdt(:,:,jk) = ( ( ta(:,:,jk) - tb(:,:,jk) ) / r2dt(jk) ) - ztrdt(:,:,jk)
-            ztrds(:,:,jk) = ( ( sa(:,:,jk) - sb(:,:,jk) ) / r2dt(jk) ) - ztrds(:,:,jk)
+            ztrdt(:,:,jk) = ( ( tsa(:,:,jk,jp_tem) - tsb(:,:,jk,jp_tem) ) / r2dt(jk) ) - ztrdt(:,:,jk)
+            ztrds(:,:,jk) = ( ( tsa(:,:,jk,jp_sal) - tsb(:,:,jk,jp_sal) ) / r2dt(jk) ) - ztrds(:,:,jk)
          END DO
-         CALL trd_mod( ztrdt, ztrds, jptra_trd_zdf, 'TRA', kt )
+         CALL trd_tra( kt, 'TRA', jp_tem, jptra_trd_zdf, ztrdt )
+         CALL trd_tra( kt, 'TRA', jp_sal, jptra_trd_zdf, ztrds )
+         DEALLOCATE( ztrdt )      ;     DEALLOCATE( ztrds ) 
       ENDIF
 
       !                                          ! print mean trends (used for debugging)
-      IF(ln_ctl)   CALL prt_ctl( tab3d_1=ta, clinfo1=' zdf  - Ta: ', mask1=tmask,               &
-         &                       tab3d_2=sa, clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
+      IF(ln_ctl)   CALL prt_ctl( tab3d_1=tsa(:,:,:,jp_tem), clinfo1=' zdf  - Ta: ', mask1=tmask,               &
+         &                       tab3d_2=tsa(:,:,:,jp_sal), clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
 
    END SUBROUTINE tra_zdf
 
 
-   SUBROUTINE zdf_ctl
+   SUBROUTINE tra_zdf_init
       !!----------------------------------------------------------------------
-      !!                 ***  ROUTINE zdf_ctl  ***
+      !!                 ***  ROUTINE tra_zdf_init  ***
       !!
       !! ** Purpose :   Choose the vertical mixing scheme
@@ -153,5 +153,5 @@
       IF(lwp) THEN
          WRITE(numout,*)
-         WRITE(numout,*) 'tra:zdf_ctl : vertical tracer physics scheme'
+         WRITE(numout,*) 'tra_zdf_init : vertical tracer physics scheme'
          WRITE(numout,*) '~~~~~~~~~~~'
          IF( nzdf == -1 )   WRITE(numout,*) '              ESOPA test All scheme used'
@@ -160,5 +160,5 @@
       ENDIF
 
-   END SUBROUTINE zdf_ctl
+   END SUBROUTINE tra_zdf_init
 
    !!==============================================================================
